/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

// ChoicesDialog.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "ChoicesDialog.h"
#include "wceolsrdv2Dlg.h"


#include "defs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif









/////////////////////////////////////////////////////////////////////////////
// CChoicesDialog dialog


CChoicesDialog::CChoicesDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CChoicesDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChoicesDialog)
	m_trace = FALSE;
	m_debug = FALSE;
	m_filename = _T("");
	m_tofile = -1;
	m_toscreen = -1;
	//}}AFX_DATA_INIT
}

BOOL CChoicesDialog::OnInitDialog()
{	
	TCHAR Ldevname[41];
	int i;

	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	if (!PICAgetAvailableDevices(&devs)) {
		AfxMessageBox(L"Error getting available devices",MB_OK,0);
		exit(-1);
	}

	for (i=0;i<devs.num_devices;i++) {
		if (!ascii_unicode(devs.dev_names[i],Ldevname, 40)) {
			AfxMessageBox(L"Error converting from ASCII to UNICODE",MB_OK,0);			
		}
		
		m_devices.InsertString(i,Ldevname);
	}
	
	m_devices.SetCurSel(0);

	m_filename = L"\\Temp\\trace.txt";	

	m_tlevel.SetWindowText(L"1");
	m_spin.SetBuddy((CWnd *) &m_tlevel);
	m_spin.SetRange(1,4);

	UpdateData(FALSE);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChoicesDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChoicesDialog)
	DDX_Control(pDX, IDC_SPIN1, m_spin);
	DDX_Control(pDX, IDC_TRACE_LEVEL, m_tlevel);
	DDX_Control(pDX, IDC_DEVICES, m_devices);
	DDX_Check(pDX, IDC_TRACE, m_trace);
	DDX_Check(pDX, IDC_DEBUG, m_debug);
	DDX_Text(pDX, IDC_FILE, m_filename);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChoicesDialog, CDialog)
	//{{AFX_MSG_MAP(CChoicesDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChoicesDialog message handlers

void CChoicesDialog::OnOK() 
{
	// TODO: Add extra validation here
	
	CWceolsrdv2Dlg dlg;	
	TCHAR level[4];

	sprintf(dlg.opts.device,"%s",devs.dev_names[m_devices.GetCurSel()]);
	UpdateData();

	if (m_trace) {
		dlg.opts.trace = 1;
		unicode_ascii((LPCTSTR) m_filename,dlg.opts.tracefile,64);		
	}
	else dlg.opts.trace = 0;

	if (m_debug) dlg.opts.debug = 1;
	else dlg.opts.debug = 0;

	m_tlevel.GetWindowText(level,3);

	swscanf(level,L"%d",&dlg.opts.tracelevel);	 
	

	dlg.DoModal();

	//CDialog::OnOK();
}

