/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 *
 *	$Id: duplicate_table.h,v 1.2 2000/12/06 10:36:11 prima Exp $
 */

/*
 * Routing table management daemon.
 */


/*
 *Duplicate table structure.
 */

struct duplicateinfo {
	olsr_u32_t     duplicate_hash;
        olsr_ip_addr     duplicate_addr;
	olsr_u16_t      duplicate_seq;
        struct timeval duplicate_timer;		        
};


struct duplicate_entry {
	struct	duplicate_entry *duplicate_forw;
	struct	duplicate_entry *duplicate_back;
        struct  duplicateinfo duplicate_infos;
};


#define	duplicate_hash      	duplicate_infos.duplicate_hash
#define	duplicate_addr      	duplicate_infos.duplicate_addr       /* originator address of 
									the received TC packet */
#define	duplicate_seq    	duplicate_infos.duplicate_seq        /* packet sequence number */
#define	duplicate_timer     	duplicate_infos.duplicate_timer      /* for invalidation */

struct duplicatehash {
	struct	duplicate_entry *duplicate_forw;
	struct	duplicate_entry *duplicate_back;
};



void
olsr_delete_duplicate_table(struct duplicate_entry *dup_entry);

int
olsr_insert_duplicate_table(struct tc_message *message);

struct duplicate_entry
*olsr_lookup_duplicate_table(struct tc_message *message);

int
olsr_release_duplicate_table();

int
olsr_time_out_duplicate_table();

int
olsr_print_duplicate_table();
