/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 */
/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

/*
 * Copyright (c) 1983, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "stdafx.h"


char copyright[] =
  "@(#) Copyright (c) 2000, 2001\n"
  "  INRIA-HIPERCOM.  All rights reserved.\n";

/*
 * From: @(#)main.c	5.23 (Berkeley) 7/1/91
 * From: @(#)main.c	8.1 (Berkeley) 6/5/93
 * From: @(#)main.c	1.7 (dholland Exp)  1997/05/19
 */

char main_rcsid[] = 
  "$Id: main.c,v 1.2 2000/12/06 10:36:11 prima Exp $";

/*
 * Routing Table Management Daemon
 */

#include "defs.h"

//#include "wceolsrdv2Dlg.h"

#ifdef PICA_LINUX
//#include <sys/ioctl.h>
//#include <sys/file.h>
//#include <syslog.h>
//#include <sys/utsname.h>
#endif

//#include <net/if.h>

//#include <errno.h>
//#include <signal.h>


#define LOG_PATH "\\Temp\\olsrd_log.txt"


struct sockaddr_in addr;        /* Address used as Originator Address */
olsr_ip_addr addr_ip;           /* sin_addr.s_addr member of the 
				   variable addr */
struct sockaddr_in addrsock;	/* address of daemon's socket */
int s;				/* source and sink of all data */
char	packet[MAXPACKETSIZE+1];
int     outputsize = 0;         /* current size of the 
				   output buffer (packet) */
struct	servent *sp;
//sigset_t sigset, osigset, psigset;

struct interf_name *interf_names = NULL; /* list of interface type on which olsr 
					    packets will be send */

int	supplier = 1;		/* process should supply updates */
int     option_i = 0;
int     filter = 0;
int	gateway = 0;		/* 1 if we are a gateway to parts beyond */
int	debug = 0;
int	bufspace = 127*1024;	/* max. input buffer size to request */
struct	olsr *msg = (struct olsr *)packet;

short     hello_seqnum = 1;     /* Hello packet counter which is use 
				   as unique identifier to HELLO PACKET */
short     tc_seqnum = 1;        /* TC packet counter which is use as unique
				   identifier to TC PACKET */

UINT64 next_event;
UINT64 timer_val;
PICAsemaphore sync_sem;
FDesc logfile;
char logdata[PICA_ERR_BUF_SIZE];

UINT64 timer_now;
PICAsemaphore timer_sem;
PICAmutex timer_exc;
THRID timer_thr;
char auxstr[256];

PICAsocket getsocket(int, int, struct sockaddr *);
void process(int);
void thrfunc(void * data);



int start(struct options * input) {

	int n, nfd, tflags = 0;
	struct timeval *tvp, waittime;
	struct itimerval itval;
	fd_set ibits;
    struct tc_message tcpack;
    struct hello_message hellopack;
	struct _interface *ifp;
	//PICA
	PICAdescList * dl = NULL;
	PICAselResult res;	
	int admin, dif;
        //temp
	char err[100];
	int code;


	PICAstartup(0);



	if (!PICAisAdministrator(&admin)) {
	    printf("Unable to check user.\r\n");
	    exit(-1);
	}
	if (!admin) {
	    fprintf(stderr,"You must have administrator previledges!\r\n");
	    exit(-1);
	}

	if (!PICAsetForwarding(FWD_ON)) {
	    fprintf(stderr,"Unable to turn on IP forwarding.\r\n");
	    exit(-1);
	}




	if (!PICAopenFile(&logfile, LOG_PATH,WRITEF, APPEND)) {
	    sprintf(auxstr,"Unable to open log at: %s\r\n", LOG_PATH);
		printf(auxstr);
	    exit(-1);
	}

	sprintf(logdata, "Starting log! \n");
	LOG(logdata);



        sp = (struct servent *) malloc( sizeof(*sp));
	if (sp == 0) {
		printf("olsrd: out of memory\r\n");
		exit(1);
	}
        sp->s_name = "olsr";
        sp->s_aliases = NULL;
	sp->s_port = htons(OLSRPORT);
        sp->s_proto = "udp";
	memset(&addrsock, 0, sizeof (addrsock));
        addrsock.sin_family = AF_INET;
	addrsock.sin_port = sp->s_port;
	(addrsock.sin_addr).s_addr = INADDR_ANY;

	s = getsocket(AF_INET, SOCK_DGRAM, (struct sockaddr *)&addrsock);

	if (s < 0)
		exit(1);



	
	
/*
 * Process olsrd options.
 */

         /*
          * With this option all packets sent or received are printed on the 
          * standard output or in a specified file (the file name is the last 
          * argument of olsrd). In this case olsrd will not divorce itsef from
          * the controlling terminal. So interrupts from the keyboard will
          * kill the process.
          */

		
		if (input->trace == 1) {
			printf("Trace enabled\r\n");
			tflags++;			
			traceon(input->tracefile);
			//sprintf(auxstr,"Level is %d\r\n",input->tracelevel);
			//printf(auxstr);
			while(input->tracelevel--)				
				bumploglevel();
		}


        /*
         * Enable additional debugging information to be logged.
         */
		
		if (input->debug == 1) {
			printf("Debug enabled\r\n");
			debug++;
		}

        
	/*
	 * To specify the name of an interface to be used by olsrd.
	 * Is required if more than one interface have configuured.
	 */
		
	        option_i = 1;
		
			ifchoice(input->device);
		
		
	
	ifinit_PICA();

	

        /*
         * To divorce the processe from the controlling terminal.
         * So interrupts from the keyboard won't kill the process.
         */

/*
#ifdef PICA_LINUX
	if (debug == 0 && tflags == 0)
	{
	    if (daemon(1,0)) exit(-1); 
	}
#endif
*/

	/*
	 * Any extra argument is considered
	 * a tracing log file.
	 */

	 

	gettime2(&now,&timer_now);


        /* Choice of the Originator address. In this version ifnet contain
	   one interface */

	memset(&addr, 0, sizeof (addr));
	for (ifp = ifnet; ifp; ifp = ifp->int_next) {
/*		if (ifp->int_flags & IFF_PASSIVE )
		continue;*/
		addr = *(struct sockaddr_in *)&ifp->int_addr;
                break;
	}
	
	if (ifp)
	 addr_ip = addr.sin_addr.s_addr;
        else 
	  exit(1);

		
	/* Initialisation of differents tables to be used.*/

        olsr_init_tables();
        
		

        if (filter)    
         load_topology_filter();
     
       /* 
        * Build and send empty HELLO.
        */

        hellopack.neighbors = (struct hello_neighbor *)NULL;
        olsr_build_hello_packet(&hellopack);
   
        toall(hello_build, &hellopack, (struct tc_message *)NULL,
             (struct _interface *)NULL);
        toall(sndmsg, (struct hello_message *)NULL, 
             (struct tc_message *)NULL, (struct _interface *)NULL);



	next_event = timer_now + (TIMER_RATE * 1000);

  
	
	if (!PICAaddDesc(&dl, PICA_SOCKET_TYPE,PICA_W_READ, &s)) {
	    printf("Unable to add descriptor for select\r\n");
	    exit(-1);
	}


			

	for (;;){



		dif = next_event-PICAgetCurrTime();						
		if (dif < 0) dif = 0;					

	    if (!PICAselect(dif, dl, &res)) { 	    

			exit(0);

		

	    } else {	    	
				
			if (res.type == PICA_TIMEOUT_TYPE) {

				timer(NULL);		
				next_event += (TIMER_RATE * 1000);
			} else { //begin socket handling			

					gettime2(&now,&timer_now);							
					
					if (*((PICAsocket *) (res.desc)) == s) {
			
					   process(s);
						
					} else printf("Unknown error: sockets do not match\r\n");


			} //end socket handling


	    } //else from PICAselect
	 

	} /* for(;;) */


}



void process(int fd)
{
	struct sockaddr from;
	size_t fromlen;
	int cc;
	union {
		char	buf[MAXPACKETSIZE+1];
		struct	olsr olsr;
	} inbuf;

	for (;;) {
		fromlen = sizeof (from);
		cc = recvfrom(fd, (char *) &inbuf, sizeof (inbuf), 0, &from, 
			      (int *) &fromlen);
		if (cc <= 0) {
#ifdef PICA_LINUX
			if (cc < 0 && errno != EWOULDBLOCK)
				perror("recvfrom");
#else
			if (cc < 0 && WSAGetLastError() != WSAEWOULDBLOCK)
			printf("Error receiving data from socket\r\n");
#endif
			break;
		}
	
		if (fromlen != sizeof (struct sockaddr_in))
			break;


		olsr_input(&from, &inbuf.olsr, cc);
	
	}
}


PICAsocket getsocket(int domain, int type, struct sockaddr *sa)
{
	struct sockaddr_in *sin=(struct sockaddr_in *)sa;
	int on = 1, longueur;
	u_long non_block = 1;
	PICAsocket sock;


	if (!PICAcreateSocket(&sock,domain, type, 0)) {

		printf("Error creating socket\r\n");

	    sprintf(logdata, "socket: unable to create socket\n");
	    LOG(logdata);
	    return (-1);
	}

#ifdef SO_BROADCAST
	if (setsockopt(sock, SOL_SOCKET, SO_BROADCAST,(char *) &on, sizeof (on)) < 0)
	  {

		sprintf(logdata, "setsockopt SO_BROADCAST: %d",WSAGetLastError());
	    LOG(logdata);
		PICAcloseSocket(sock);
		return (-1);
	  }
#endif
/*
#ifdef SO_RCVBUF
	for (on = bufspace; ; on -= 1024) {
		if (setsockopt(sock, SOL_SOCKET, SO_RCVBUF,(char *) &on, sizeof (on)) == 0)
			break;
		if (on <= 8*1024) {
			//syslog(LOG_ERR, "setsockopt SO_RCVBUF: %m");
			sprintf(logdata, "setsockopt SO_RCVBUF: %m");
			LOG(logdata);
			break;
		}
	}
	if (traceactions)
		fprintf(ftrace, "recv buf %d\n", on);
#endif
*/

	if (bind(sock, (struct sockaddr *)sin, sizeof (*sin)) < 0) {

		printf("Error binding socket\r\n");
		sprintf(logdata, "bind: %m");
		LOG(logdata);
		PICAcloseSocket(sock);
		return (-1);
	}


	if (ioctlsocket(sock,FIONBIO,&non_block) != 0) {
		sprintf(logdata, "ioctlsocket: error putting socket in nonblocking mode\n");
	    LOG(logdata);
	}

	return (sock);
}

void LOG(char * data) {
    
    char logdata2[256], * date_str;

    PICAgetTimeStr(&date_str);
    sprintf(logdata2, "%s> %s\n",date_str, data);
    PICAwriteToFile(logfile, logdata2, strlen(logdata2));  
    //free(date_str);

}

