/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

/*
 * This Copyright notice is in French. An English summary is given
 * but the referee text is the French one.
 *
 * Copyright (c) 2000, 2001 Adokoe.Plakoo@inria.fr, INRIA Rocquencourt,
 *                          Anis.Laouiti@inria.fr, INRIA Rocquencourt.
 *
 * Ce logiciel informatique est disponible aux conditions
 * usuelles dans la recherche, c'est--dire qu'il peut
 * tre utilis, copi, modifi, distribu  l'unique
 * condition que ce texte soit conserv afin que
 * l'origine de ce logiciel soit reconnue.
 * Le nom de l'Institut National de Recherche en Informatique
 * et en Automatique (INRIA), ou d'une personne morale
 * ou physique ayant particip  l'laboration de ce logiciel ne peut
 * tre utilis sans son accord pralable explicite.
 * 
 * Ce logiciel est fourni tel quel sans aucune garantie,
 * support ou responsabilit d'aucune sorte.
 * Certaines parties de ce logiciel sont drives de sources developpees par
 * University of California, Berkeley et ses contributeurs couvertes 
 * par des copyrights.
 * This software is available with usual "research" terms
 * with the aim of retain credits of the software. 
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies,
 * and the name of INRIA, or any contributor not be used in advertising
 * or publicity pertaining to this material without the prior explicit
 * permission. The software is provided "as is" without any
 * warranties, support or liabilities of any kind.
 * This product includes software developed by the University of
 * California, Berkeley and its contributors protected by copyrights.
 */

#include "stdafx.h"

char timer_rcsid[] = 
  "$Id: timer.c,v 1.2 2000/12/06 10:36:12 prima Exp $";

/*
 * Routing Table Management Daemon
 */

#include "defs.h"

int sincelast_tc = 0;      /* Time last since we send last TC packet */
int sincelast_hello = 0;   /* Time last since we send last HELLO packetc */

/*
 * Timer routine. Performs neighbor and topology information supply
 * duties and manages timers on all tables' entries.
 */

void gettime2(struct timeval * t_n, UINT64 * t_p) {
    UINT64 time_aux;

    time_aux = PICAgetCurrTime();

    if (t_p != NULL) *t_p = time_aux;
    if (t_n != NULL) {
	t_n->tv_sec = time_aux / 1000;
	t_n->tv_usec = (time_aux % 1000) * 1000;
    }

} 


void timeradd(struct timeval * a,struct timeval * b, struct timeval * result) {
	(result)->tv_sec = (a)->tv_sec + (b)->tv_sec;
	(result)->tv_usec = (a)->tv_usec + (b)->tv_usec;
	if ((result)->tv_usec >= 1000000)
	{
		++(result)->tv_sec;
		(result)->tv_usec -= 1000000;
	}
} 


//void timer(int signum)
void timer(void * param)
{

	struct itimerval itval;
        struct hello_message hellopacket;
        struct tc_message tcpacket;
	int timetobroadcast_hello, timetobroadcast_tc;

        tcpacket.multipoint_relay_selector_address = 
	                                       (struct tc_mpr_addr *)NULL;

        hellopacket.neighbors = (struct hello_neighbor *)NULL;


	gettime2(&now,&timer_now);

        sincelast_hello += TIMER_RATE;
        sincelast_tc += TIMER_RATE;

	timetobroadcast_hello = supplier && sincelast_hello 
	                                    >= HELLO_INTERVAL;
        timetobroadcast_tc = changes ? supplier && 
	                            sincelast_tc >= MIN_TC_INTERVAL : 
                                    supplier && sincelast_tc 
	                                        >= TC_INTERVAL;

        /* Advance time on differents tables entry */

	olsr_delete_time_out_entries();

	if (timetobroadcast_hello) {

	  olsr_build_hello_packet(&hellopacket);

	  toall(hello_build, &hellopacket, (struct tc_message *)NULL, 
                                            (struct _interface *)NULL);
	  sincelast_hello = 0;
	}
        
	if (timetobroadcast_tc) {

	  olsr_build_tc_packet(&tcpacket);
 
	  toall(tc_build, (struct hello_message *)NULL, &tcpacket,  
                           (struct _interface *)NULL);
	  sincelast_tc = 0;
          changes = 0;
	}

	if (outputsize)
	  toall(sndmsg, (struct hello_message *)NULL, 
                (struct tc_message *)NULL,  (struct _interface *)NULL );


}
