/*****************************************************************************
 *
 * 2002 Polytechnic University of Valencia.
 *
 * This program was ported to the Windows 2000 / Windows CE 3.0 platforms
 * by Carlos Miguel Tavares Calafate.
 *
 * For licencing information, see the licence provided by INRIA, which is
 * a Berkeley Copyright licence.
 *
 * For more info on the Windows 2000 and Windows CE versions, check the site:
 *
 * http://reptar.grc.upv.es/~calafate/
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

// wceolsrdv2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "wceolsrdv2.h"
#include "wceolsrdv2Dlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWceolsrdv2Dlg dialog

CWceolsrdv2Dlg::CWceolsrdv2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWceolsrdv2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWceolsrdv2Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWceolsrdv2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWceolsrdv2Dlg)
	DDX_Control(pDX, IDC_START, m_start);
	DDX_Control(pDX, IDC_TEXT, m_text);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWceolsrdv2Dlg, CDialog)
	//{{AFX_MSG_MAP(CWceolsrdv2Dlg)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWceolsrdv2Dlg message handlers

BOOL CWceolsrdv2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	
	initialize_communication(&m_text);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CWceolsrdv2Dlg::OnExit() 
{
	// TODO: Add your control notification handler code here

	PICAkillThread(olsr_thr);

	exit(0);

//	CWceolsrdv2Dlg::OnOK();	
}

void CWceolsrdv2Dlg::OnStart() 
{
	// TODO: Add your control notification handler code here	

	
	printf("Starting OLSR daemon\r\n");

	PICAstartThread(&olsr_thr, start, (void *) &opts);
	if (!SetThreadPriority(olsr_thr,THREAD_PRIORITY_HIGHEST)) {
		exit(-1);
	}

	m_start.ShowWindow(SW_HIDE);
}

void CWceolsrdv2Dlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	PICAkillThread(olsr_thr);

	cleanup();
	

	
//	CWceolsrdv2Dlg::OnOK();
}
